
# A very simple test. I'm not entirely sure how to test the correctness of the
# SAA stuff.

using Test
include("../example/simulate_data.jl")

# Just for one data point.
function naive_nll(p)
  K = cholesky!(Symmetric([kfn(x,y,p) for x in pts, y in pts]))
  0.5*(logdet(K) + dot(simul, K\simul))
end

function efish(p)
  out = zeros(2,2)
  K   = cholesky!(Symmetric([kfn(x,y,p) for x in pts, y in pts]))
  Kd1 = Symmetric([kd1(x,y,p) for x in pts, y in pts])
  Kd2 = Symmetric([kd2(x,y,p) for x in pts, y in pts])
  out[1,1] = tr(K\(Kd1*(K\Kd1)))
  out[1,2] = tr(K\(Kd2*(K\Kd1)))
  out[2,1] = out[1,2]
  out[2,2] = tr(K\(Kd2*(K\Kd2)))
  Symmetric(out./2)
end

const GPMAXTEST = GPMaxlik.gnll(pts, simul, kfn, (kd1, kd2), [3.0, 3.0], saa=nothing,
                                nll=true, grad=true, fish=true, vrb=false)

@test isapprox(GPMAXTEST.nll, naive_nll([3.0, 3.0]))
@test isapprox(GPMAXTEST.grad, ForwardDiff.gradient(naive_nll, [3.0, 3.0]))
@test isapprox(GPMAXTEST.fish, efish([3.0, 3.0]))

